/* client.h -- 
 *  Copyright (c) Distributed Multimedia Computing Laboratory,
 *                The University of Texas at Austin. 1996
 *                All Rights Reserved..
 * Author          : Prashant J. Shenoy
 * Created On      : Mon May  6 20:17:27 1996
 * Last Modified By: Prashant J. Shenoy
 * Last Modified On: Thu Jul 11 20:57:57 1996
 * Update Count    : 24
 * Status          : Unknown, Use with caution!
 */


#ifndef _CLIENT_H
#define _CLIENT_H

#include "defns.h"
#include "disk.h"


struct client{
int id; /* client id */
FileType type;
RetrievalMode mode; /* push/pull */
int holdTime;
int file;
int block;
int dataInBuffer;
int framesInBuffer;
int playfp; /* frame that isbeing played */
int requestSize; /* avg request size for text */
int framesPerRound;
};

typedef struct client Client;
typedef int FrameTableElem;


struct inode{
 int disk;
 int block;
 int size;
 int residue;
 int firstFrame;
 int lastFrame;
};
typedef struct inode Inode;

struct file_table_element{
 FileType type;
 Inode inode[MAX_BLOCKS];
 int numBlocks;
 int blockSize;
 int startfp;
};

typedef struct file_table_element FileTableElem;


/* ______ globals _______ */
extern int frameTableSize;
extern FrameTableElem *frameTable;
extern int fileTableSize;
extern FileTableElem *fileTable;
extern Client *clientTable; 

#endif




