/* defns.h -- Global includes, macros and constants for the simulator
 *  Copyright (c) Distributed Multimedia Computing Laboratory,
 *                The University of Texas at Austin. 1996
 *                All Rights Reserved..
 * Author          : Prashant J. Shenoy
 * Created On      : Tue Apr  2 17:39:03 1996
 * Last Modified By: Prashant J. Shenoy
 * Last Modified On: Tue Jun 24 17:22:01 1997
 * Update Count    : 31
 * Status          : Unknown, Use with caution!
 */

#ifndef _DEFNS_H
#define _DEFNS_H

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <csim.h>


#define null_string(x) (x[0] == '\0')
#define null_ptr(x)    ( x == NULL )
#define salloc(size,type)   (type *) calloc(size , sizeof(type))
#define error(errstr,errno) { fprintf(stderr,"%s",errstr);\
                              exit(errno);\
                            }
#define max(a,b)  (((a) < (b)) ? (b) : (a))
#define min(a,b)    (((a) < (b)) ? (a) : (b))


#define E_ARGS -1
#define E_IO -2
#define E_GENERIC -3
#define E_MEM -4

const int DEFAULT_PARITY_GROUP_SIZE = 1 ; /* kB */
const int MAX_STR = 256;
const int MAX_REQUESTS = 500;
const int MAX_FRAMES = 5400;
const int MAX_BLOCKS = 2000;
const int INFINITY = 1000000000;
const int MAX_PENDING_REQUESTS = 50; 
const int NORMAL=0;
const int IDLE=1;
const int  WORK_CONSERVE= 0x1;
#endif


